/*******************************************************************************
 * Copyright (c) {2007, 2008} Engineering Ingegneria Informatica S.p.A.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors: Andrea Zoppello (Engineering) - initial API and implementation
 *******************************************************************************/
package org.eclipse.stp.im.tool.in.bpmneditor.dnd;

import org.eclipse.core.runtime.IAdapterFactory;
import org.eclipse.stp.bpmn.dnd.IDnDHandler;
import org.eclipse.stp.im.tool.in.bpmneditor.dnd.handler.ExpressionDndHandler;
import org.eclipse.stp.im.tool.in.bpmneditor.view.ExpressionTreeElement;

public class ExpressionTreeElementAdapterFactory implements IAdapterFactory {     

    @SuppressWarnings("unchecked")
 	public Object getAdapter(Object adaptableObject, Class adapterType) {
    	if (adapterType.equals(IDnDHandler.class)) {
 			if (adaptableObject instanceof ExpressionTreeElement) {
 				ExpressionTreeElement expression = (ExpressionTreeElement)adaptableObject;
 				
 				return new ExpressionDndHandler(expression);
 			}
 		}
 		return null;
 	}

 	
 	/**
      * Returns the collection of adapter types handled by this
      * factory.
      * <p>
      * This method is generally used by an adapter manager
      * to discover which adapter types are supported, in advance
      * of dispatching any actual <code>getAdapter</code> requests.
      * </p>
      *
      * @return the collection of adapter types
      */
 	@SuppressWarnings("unchecked")
 	public Class[] getAdapterList() {
 		return new Class[] {IDnDHandler.class};
 	}
}
