/*******************************************************************************
 * Copyright (c) {2007} {INRIA and Engineering}.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    {Adrian Mos (INRIA) and Andrea Zoppello (Engineering)} - initial API and implementation
 *******************************************************************************/
package org.eclipse.stp.im.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.stp.im.ImPackage;
import org.eclipse.stp.im.Step;
import org.eclipse.stp.im.Transition;
import org.eclipse.stp.im.Variable;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Process</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.stp.im.impl.ProcessImpl#getSteps <em>Steps</em>}</li>
 *   <li>{@link org.eclipse.stp.im.impl.ProcessImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.stp.im.impl.ProcessImpl#getDescritpion <em>Descritpion</em>}</li>
 *   <li>{@link org.eclipse.stp.im.impl.ProcessImpl#getTransitions <em>Transitions</em>}</li>
 *   <li>{@link org.eclipse.stp.im.impl.ProcessImpl#getProcessVariables <em>Process Variables</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ProcessImpl extends ServiceImpl implements org.eclipse.stp.im.Process {
	/**
	 * The cached value of the '{@link #getSteps() <em>Steps</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSteps()
	 * @generated
	 * @ordered
	 */
	protected EList<Step> steps;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #getDescritpion() <em>Descritpion</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescritpion()
	 * @generated
	 * @ordered
	 */
	protected static final String DESCRITPION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDescritpion() <em>Descritpion</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDescritpion()
	 * @generated
	 * @ordered
	 */
	protected String descritpion = DESCRITPION_EDEFAULT;

	/**
	 * The cached value of the '{@link #getTransitions() <em>Transitions</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getTransitions()
	 * @generated
	 * @ordered
	 */
	protected EList<Transition> transitions;

	/**
	 * The cached value of the '{@link #getProcessVariables() <em>Process Variables</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getProcessVariables()
	 * @generated
	 * @ordered
	 */
	protected EList<Variable> processVariables;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ProcessImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	protected EClass eStaticClass() {
		return ImPackage.Literals.PROCESS;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Step> getSteps() {
		if (steps == null) {
			steps = new EObjectContainmentEList<Step>(Step.class, this, ImPackage.PROCESS__STEPS);
		}
		return steps;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ImPackage.PROCESS__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDescritpion() {
		return descritpion;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDescritpion(String newDescritpion) {
		String oldDescritpion = descritpion;
		descritpion = newDescritpion;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ImPackage.PROCESS__DESCRITPION, oldDescritpion, descritpion));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Transition> getTransitions() {
		if (transitions == null) {
			transitions = new EObjectContainmentEList<Transition>(Transition.class, this, ImPackage.PROCESS__TRANSITIONS);
		}
		return transitions;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList<Variable> getProcessVariables() {
		if (processVariables == null) {
			processVariables = new EObjectContainmentEList<Variable>(Variable.class, this, ImPackage.PROCESS__PROCESS_VARIABLES);
		}
		return processVariables;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs) {
		switch (featureID) {
			case ImPackage.PROCESS__STEPS:
				return ((InternalEList<?>)getSteps()).basicRemove(otherEnd, msgs);
			case ImPackage.PROCESS__TRANSITIONS:
				return ((InternalEList<?>)getTransitions()).basicRemove(otherEnd, msgs);
			case ImPackage.PROCESS__PROCESS_VARIABLES:
				return ((InternalEList<?>)getProcessVariables()).basicRemove(otherEnd, msgs);
		}
		return super.eInverseRemove(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object eGet(int featureID, boolean resolve, boolean coreType) {
		switch (featureID) {
			case ImPackage.PROCESS__STEPS:
				return getSteps();
			case ImPackage.PROCESS__NAME:
				return getName();
			case ImPackage.PROCESS__DESCRITPION:
				return getDescritpion();
			case ImPackage.PROCESS__TRANSITIONS:
				return getTransitions();
			case ImPackage.PROCESS__PROCESS_VARIABLES:
				return getProcessVariables();
		}
		return super.eGet(featureID, resolve, coreType);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@SuppressWarnings("unchecked")
	@Override
	public void eSet(int featureID, Object newValue) {
		switch (featureID) {
			case ImPackage.PROCESS__STEPS:
				getSteps().clear();
				getSteps().addAll((Collection<? extends Step>)newValue);
				return;
			case ImPackage.PROCESS__NAME:
				setName((String)newValue);
				return;
			case ImPackage.PROCESS__DESCRITPION:
				setDescritpion((String)newValue);
				return;
			case ImPackage.PROCESS__TRANSITIONS:
				getTransitions().clear();
				getTransitions().addAll((Collection<? extends Transition>)newValue);
				return;
			case ImPackage.PROCESS__PROCESS_VARIABLES:
				getProcessVariables().clear();
				getProcessVariables().addAll((Collection<? extends Variable>)newValue);
				return;
		}
		super.eSet(featureID, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public void eUnset(int featureID) {
		switch (featureID) {
			case ImPackage.PROCESS__STEPS:
				getSteps().clear();
				return;
			case ImPackage.PROCESS__NAME:
				setName(NAME_EDEFAULT);
				return;
			case ImPackage.PROCESS__DESCRITPION:
				setDescritpion(DESCRITPION_EDEFAULT);
				return;
			case ImPackage.PROCESS__TRANSITIONS:
				getTransitions().clear();
				return;
			case ImPackage.PROCESS__PROCESS_VARIABLES:
				getProcessVariables().clear();
				return;
		}
		super.eUnset(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean eIsSet(int featureID) {
		switch (featureID) {
			case ImPackage.PROCESS__STEPS:
				return steps != null && !steps.isEmpty();
			case ImPackage.PROCESS__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case ImPackage.PROCESS__DESCRITPION:
				return DESCRITPION_EDEFAULT == null ? descritpion != null : !DESCRITPION_EDEFAULT.equals(descritpion);
			case ImPackage.PROCESS__TRANSITIONS:
				return transitions != null && !transitions.isEmpty();
			case ImPackage.PROCESS__PROCESS_VARIABLES:
				return processVariables != null && !processVariables.isEmpty();
		}
		return super.eIsSet(featureID);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (name: ");
		result.append(name);
		result.append(", descritpion: ");
		result.append(descritpion);
		result.append(')');
		return result.toString();
	}

} //ProcessImpl
